var recBtn = document.getElementById("record");
var playBtn = document.getElementById("play");
var isRecording = false;
var isPlaying = false;
var mediaRecorder;

var audio = document.createElement('audio');
document.body.appendChild(audio);

recBtn.addEventListener("click", record);
playBtn.addEventListener("click", play);

init();

//toggle playback and record buttons, change their desciption and enable or disable them.
function record() {
    if (!isRecording) {
        if (mediaRecorder) {
            mediaRecorder.start();
            console.log("recorder started");
            recBtn.textContent = "Stop Recording";
            isRecording = true;
        }
    } else {
        mediaRecorder.stop();
        console.log("recorder stopped");
        recBtn.textContent = "Start Recording";
        playBtn.disabled = false;
        isRecording = false;
    }
}

function play() {
    if (!isPlaying) {
        if (audio) {
            audio.play();
            playBtn.textContent = "Stop Playing";
            recBtn.disabled = true;
            isPlaying = true;
        }
    } else {
        audio.pause();
        audio.currentTime = 0;
        playBtn.textContent = "Start Playing";
        recBtn.disabled = false;
        isPlaying = false;
    }
}

function init() {
    navigator.getUserMedia = navigator.mozGetUserMedia;

    if (navigator.getUserMedia) {
        console.log('getUserMedia supported.');

        var constraints = {
            audio: true
        };

        var onSuccess = function (stream) {
            mediaRecorder = new MediaRecorder(stream);

            mediaRecorder.ondataavailable = function (e) {
                console.log("data available after MediaRecorder.stop() called.");
                console.log("MIME Type: " + mediaRecorder.mimeType);

                //audio.setAttribute('controls', '');
                var audioURL = window.URL.createObjectURL(e.data);
                audio.src = audioURL;
                var a = document.createElement("a");
                a.href = audioURL;
                a.download = "recording.wav";
                a.textContent = "Download";
                document.body.appendChild(a);
            }
        };

        var onError = function (err) {
            console.log('The following error occured: ' + err);
        }

        navigator.getUserMedia(constraints, onSuccess, onError);
    } else {
        console.log('getUserMedia not supported on your browser!');
    }

}