var recBtn = document.getElementById("record");
var playBtn = document.getElementById("play");
var isRecording = false;
var isPlaying = false;
var mediaRecorder;
var i = 0;

var video = document.getElementById("video");

recBtn.addEventListener("click", record);
playBtn.addEventListener("click", play);

init();

function record() {
    if (!isRecording) {
        if (mediaRecorder) {
            mediaRecorder.start();
            console.log("recorder started");
            recBtn.textContent = "Stop Recording";
            isRecording = true;
        }
    } else {
        mediaRecorder.stop();
        console.log("recorder stopped");
        recBtn.textContent = "Start Recording";
        playBtn.disabled = false;
        isRecording = false;
    }
}

function play() {
    if (!isPlaying) {
        if (video) {
            video.play();
            video.onended = play;
            playBtn.textContent = "Stop Playing";
            recBtn.disabled = true;
            isPlaying = true;
        }
    } else {
        video.pause();
        video.currentTime = 0;
        playBtn.textContent = "Start Playing";
        recBtn.disabled = false;
        isPlaying = false;
    }
}

function init() {
    navigator.getUserMedia = navigator.mozGetUserMedia;

    if (navigator.getUserMedia) {
        console.log('getUserMedia supported.');

        var constraints = {
            audio: true,
            video: true
        };

        var onSuccess = function (stream) {
            mediaRecorder = new MediaRecorder(stream);

            mediaRecorder.ondataavailable = function (e) {
                console.log("data available after MediaRecorder.stop() called.");
                console.log("MIME Type: " + mediaRecorder.mimeType);

                //video.setAttribute('controls', '');
                var videoURL = window.URL.createObjectURL(e.data);
                video.src = videoURL;
                var a = document.createElement("a");
                a.href = videoURL;
                a.download = "recording" + i + ".webm";
                a.textContent = "Download File" + i;
                document.body.appendChild(a);
                i++;
            }
        };

        var onError = function (err) {
            console.log('The following error occured: ' + err);
        }

        navigator.getUserMedia(constraints, onSuccess, onError);
    } else {
        console.log('getUserMedia not supported on your browser!');
    }

}