var height = 240;
var width = 320;
var localStream;

navigator.mozGetUserMedia({video: true}, onStream, onError);

function onStream(stream) {
    localStream = stream;
    var video = document.getElementById("video");
    video.autoplay = true;
    video.src = window.URL.createObjectURL(localStream);
}

function onError(err) {
    console.log("An error occured! " + err);
}

//code based on: http://html5doctor.com/video-canvas-magic/
//to process video-image data, an invisible backing context is needed
//to get the data and process it. afterwards it is sent to the visible context
//which draws to a visible canvas.
document.addEventListener('DOMContentLoaded', function () {
    var v = document.getElementById('video');
    var canvas = document.getElementById('canvas');
    var context = canvas.getContext('2d');
    var back = document.createElement('canvas');
    var backcontext = back.getContext('2d');

    var cw = width;
    var ch = height;

    v.addEventListener('play', function () {
        //cw = v.clientWidth;
        //ch = v.clientHeight;
        canvas.width = cw;
        canvas.height = ch;
        back.width = cw;
        back.height = ch;
        setInterval(draw, 40, v, context, backcontext, cw, ch);
    }, false);



}, false);

//draw method based on code from http://www.html5rocks.com/en/tutorials/canvas/imagefilters/
//thresholds the image at 128
function draw(v, c, bc, w, h) {
    if (v.paused || v.ended) return false;
    // First, draw it into the backing canvas
    bc.drawImage(v, 0, 0, w, h);
    // Grab the pixel data from the backing canvas
    var idata = bc.getImageData(0, 0, w, h);
    var data = idata.data;
    // Loop through the pixels, turning them grayscale
    for (var i = 0; i < data.length; i += 4) {
        var r = data[i];
        var g = data[i + 1];
        var b = data[i + 2];
        //Grayscale
        //var brightness = (3 * r + 4 * g + b) >>> 3;
        var threshold = 128;
        var brightness = (0.2126*r + 0.7152*g + 0.0722*b >= threshold) ? 255 : 0;
        data[i] = brightness;
        data[i + 1] = brightness;
        data[i + 2] = brightness;
    }
    idata.data = data;
    // Draw the pixels onto the visible canvas
    c.putImageData(idata, 0, 0);
    // Start over!
}