var canvas = document.getElementById("canvas");
var ctx = canvas.getContext("2d");
var endX;
var endY;


canvas.addEventListener("touchstart", function(event) {
    var touch = event.changedTouches[0];
    getTouchPosition(touch);
    draw();
});

function draw() {
    ctx.clearRect(0, 0, canvas.width, canvas.height);
    ctx.fillStyle = "green";
    ctx.fillRect(10, 10, endX, endY);
}

//code from http://www.kirupa.com/html5/getting_mouse_click_position.htm
function getTouchPosition(e) {
    var parentPosition = getPosition(e.target);
    endX = e.clientX - parentPosition.x;
    endY = e.clientY - parentPosition.y;
}

//this method calculates the touch point inside of the touched element 
//(in our case the canvas, so that we can draw to the touch), 
//since the touchevent only serves the absolute position inside the page.
function getPosition(element) {
    var xPosition = 0;
    var yPosition = 0;
      
    while (element) {
        xPosition += (element.offsetLeft - element.scrollLeft + element.clientLeft);
        yPosition += (element.offsetTop - element.scrollTop + element.clientTop);
        element = element.offsetParent;
    }
    return { x: xPosition, y: yPosition };
}