//https://developer.mozilla.org/en-US/docs/Web/API/Contacts_API

var list = document.getElementById("responseLi");

//create a new Contact
//all fields are arrays!
var person = new mozContact({
    name: ["John Doe"],
    givenName: ["John"],
    familyName: ["Doe"],
    tel: [{
        type: ["home"],
        value: ["0699/12345678"]
    }]
});

//get the contact Manager
var contactManager = navigator.mozContacts;
//save the contact.
var saving = contactManager.save(person);

saving.onsuccess = function () {
    console.log("New contact saved!");
};

saving.onerror = function (err) {
    console.error(err);
};

//get all contacts
var allContacts = navigator.mozContacts.getAll({
    sortBy: "familyName",
    sortOrder: "descending"
});

//print them on screen
allContacts.onsuccess = function (event) {
    var cursor = event.target;
    if (cursor.result) {
        console.log("Found: " + cursor.result.givenName[0] + " " + cursor.result.familyName[0]);
        var li = document.createElement("li");
        li.textContent = cursor.result.familyName[0] + ", " + cursor.result.givenName[0]; 
        list.appendChild(li);
        cursor.continue();
    } else {
        console.log("No more contacts");
    }
};

allContacts.onerror = function () {
    console.warn("Something went terribly wrong! :(");
};